Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3605)
@@ -4688,12 +4888,12 @@
     DO k = 1, klev
        DO i = 1, klon
-          d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / dtime
-          d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / dtime
-          d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / dtime
-          d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / dtime
-          d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / dtime
+          d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / phys_tstep
+          d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / phys_tstep
+          d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / phys_tstep
+          d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / phys_tstep
+          d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / phys_tstep
           !CR: on ajoute le contenu en glace
           IF (nqo.eq.3) THEN
-             d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / dtime
+             d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / phys_tstep
           ENDIF
        ENDDO
@@ -4707,6 +4907,6 @@
           DO  k = 1, klev
              DO  i = 1, klon
-                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / dtime
-                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / dtime
+                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / phys_tstep
+                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / phys_tstep
              ENDDO
           ENDDO
@@ -4877,5 +5077,5 @@
     CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
          pplay, lmax_th, aerosol_couple,                 &
-         ok_ade, ok_aie, ivap, iliq, isol, new_aod,      & 
+         ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, new_aod,      & 
          ok_sync, ptconv, read_climoz, clevSTD,          &
          ptconvth, d_u, d_t, qx, d_qx, zmasse,           &
@@ -4890,5 +5090,5 @@
 
 ! On remet des variables a .false. apres un premier appel
-    if (debut) then
+    IF (debut) THEN
 #ifdef CPP_XIOS
       swaero_diag=.FALSE.
@@ -4898,5 +5098,5 @@
 !      write (lunout,*)'ok_4xCO2atm= ',swaero_diag, swaerofree_diag, dryaod_diag, ok_4xCO2atm
 
-      IF (is_master) then
+      IF (is_master) THEN
         !--setting up swaero_diag to TRUE in XIOS case 
         IF (xios_field_is_active("topswad").OR.xios_field_is_active("topswad0").OR. & 
@@ -4929,13 +5129,13 @@
            xios_field_is_active("rld4co2").OR.xios_field_is_active("rldcs4co2")) &
            ok_4xCO2atm=.TRUE. 
-      endif
+      ENDIF
       !$OMP BARRIER
-      call bcast(swaero_diag)
-      call bcast(swaerofree_diag)
-      call bcast(dryaod_diag)
-      call bcast(ok_4xCO2atm)
+      CALL bcast(swaero_diag)
+      CALL bcast(swaerofree_diag)
+      CALL bcast(dryaod_diag)
+      CALL bcast(ok_4xCO2atm)
 !      write (lunout,*)'ok_4xCO2atm= ',swaero_diag, swaerofree_diag, dryaod_diag, ok_4xCO2atm
 #endif
-    endif
+    ENDIF
 
     !====================================================================
@@ -4962,19 +5162,22 @@
        !         write(97) u_seri,v_seri,t_seri,q_seri
        !         close(97)
-       !$OMP MASTER
-       IF (read_climoz >= 1) THEN
-          IF (is_mpi_root) THEN
-             CALL nf95_close(ncid_climoz)
-          ENDIF
-          DEALLOCATE(press_edg_climoz) ! pointer
-          DEALLOCATE(press_cen_climoz) ! pointer
-       ENDIF
-       !$OMP END MASTER
-       print *,' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
+      
+       IF (is_omp_master) THEN
+       
+         IF (read_climoz >= 1) THEN
+           IF (is_mpi_root) CALL nf95_close(ncid_climoz)
+            DEALLOCATE(press_edg_climoz) ! pointer
+            DEALLOCATE(press_cen_climoz) ! pointer
+         ENDIF
+       
+       ENDIF
+#ifdef CPP_XIOS
+       IF (is_omp_master) CALL xios_context_finalize
+#endif
+       WRITE(lunout,*) ' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
     ENDIF
 
     !      first=.false.
 
-
   END SUBROUTINE physiq
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phytrac_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phytrac_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phytrac_mod.F90	(revision 3605)
@@ -54,4 +54,23 @@
 CONTAINS
 
+  SUBROUTINE phytrac_init()
+    USE dimphy
+    USE infotrac_phy, ONLY: nbtr
+    IMPLICIT NONE
+
+       ALLOCATE(d_tr_cl(klon,klev,nbtr),d_tr_dry(klon,nbtr))
+       ALLOCATE(flux_tr_dry(klon,nbtr),d_tr_dec(klon,klev,nbtr),d_tr_cv(klon,klev,nbtr))
+       ALLOCATE(d_tr_insc(klon,klev,nbtr),d_tr_bcscav(klon,klev,nbtr))
+       ALLOCATE(d_tr_evapls(klon,klev,nbtr),d_tr_ls(klon,klev,nbtr))
+       ALLOCATE(qPrls(klon,nbtr),d_tr_trsp(klon,klev,nbtr))
+       ALLOCATE(d_tr_sscav(klon,klev,nbtr),d_tr_sat(klon,klev,nbtr))
+       ALLOCATE(d_tr_uscav(klon,klev,nbtr),qPr(klon,klev,nbtr),qDi(klon,klev,nbtr))
+       ALLOCATE(qPa(klon,klev,nbtr),qMel(klon,klev,nbtr))
+       ALLOCATE(qTrdi(klon,klev,nbtr),dtrcvMA(klon,klev,nbtr))
+       ALLOCATE(d_tr_th(klon,klev,nbtr))
+       ALLOCATE(d_tr_lessi_impa(klon,klev,nbtr),d_tr_lessi_nucl(klon,klev,nbtr))
+
+  END SUBROUTINE phytrac_init
+
   SUBROUTINE phytrac(                                 &
        nstep,     julien,   gmtime,   debutphy,       &
@@ -332,17 +351,4 @@
     !                    -- INITIALIZATION --
     !######################################################################
-    IF (debutphy) THEN
-       ALLOCATE(d_tr_cl(klon,klev,nbtr),d_tr_dry(klon,nbtr))
-       ALLOCATE(flux_tr_dry(klon,nbtr),d_tr_dec(klon,klev,nbtr),d_tr_cv(klon,klev,nbtr))
-       ALLOCATE(d_tr_insc(klon,klev,nbtr),d_tr_bcscav(klon,klev,nbtr))
-       ALLOCATE(d_tr_evapls(klon,klev,nbtr),d_tr_ls(klon,klev,nbtr))
-       ALLOCATE(qPrls(klon,nbtr),d_tr_trsp(klon,klev,nbtr))
-       ALLOCATE(d_tr_sscav(klon,klev,nbtr),d_tr_sat(klon,klev,nbtr))
-       ALLOCATE(d_tr_uscav(klon,klev,nbtr),qPr(klon,klev,nbtr),qDi(klon,klev,nbtr))
-       ALLOCATE(qPa(klon,klev,nbtr),qMel(klon,klev,nbtr))
-       ALLOCATE(qTrdi(klon,klev,nbtr),dtrcvMA(klon,klev,nbtr))
-       ALLOCATE(d_tr_th(klon,klev,nbtr))
-       ALLOCATE(d_tr_lessi_impa(klon,klev,nbtr),d_tr_lessi_nucl(klon,klev,nbtr))
-    ENDIF
 
     DO k=1,klev
@@ -405,9 +411,9 @@
        !Config Key  = convscav
        !Config Desc = Convective scavenging switch: 0=off, 1=on.
-       !Config Def  = .false.
+       !Config Def  = .FALSE.
        !Config Help = 
        !
 !$OMP MASTER
-       convscav_omp=.false.
+       convscav_omp=.FALSE.
        call getin('convscav', convscav_omp)
        iflag_vdf_trac_omp=1
@@ -479,4 +485,10 @@
        CASE('co2i')
           source(:,:)=0.
+          lessivage  = .FALSE.
+          aerosol(:) = .FALSE.
+          pbl_flg(:) = 1
+          iflag_the_trac= 1
+          iflag_vdf_trac= 1
+          iflag_con_trac= 1
 #ifdef CPP_StratAer
        CASE('coag')
@@ -506,23 +518,23 @@
              CASE('lmdz')
                 IF (convscav.and.aerosol(it)) THEN
-                   flag_cvltr(it)=.true.
+                   flag_cvltr(it)=.TRUE.
                    ccntrAA(it) =ccntrAA_in    !--a modifier par JYG a lire depuis fichier 
                    ccntrENV(it)=ccntrENV_in
                    coefcoli(it)=coefcoli_in
                 ELSE 
-                   flag_cvltr(it)=.false.
+                   flag_cvltr(it)=.FALSE.
                 ENDIF
 
              CASE('repr')
-                 flag_cvltr(it)=.false.
+                 flag_cvltr(it)=.FALSE.
 
              CASE('inca')
 !                IF ((it.EQ.id_Rn222) .OR. ((it.GE.id_SO2) .AND. (it.LE.id_NH3)) ) THEN 
 !                   !--gas-phase species
-!                   flag_cvltr(it)=.false.
+!                   flag_cvltr(it)=.FALSE.
 !
 !                ELSEIF ( (it.GE.id_CIDUSTM) .AND. (it.LE.id_AIN) ) THEN
 !                   !--insoluble aerosol species
-!                   flag_cvltr(it)=.true.
+!                   flag_cvltr(it)=.TRUE.
 !                   ccntrAA(it)=0.7
 !                   ccntrENV(it)=0.7
@@ -530,5 +542,5 @@
 !                ELSEIF ( (it.EQ.id_Pb210) .OR. ((it.GE.id_CSSSM) .AND. (it.LE.id_SSN))) THEN
 !                   !--soluble aerosol species
-!                   flag_cvltr(it)=.true.
+!                   flag_cvltr(it)=.TRUE.
 !                   ccntrAA(it)=0.9
 !                   ccntrENV(it)=0.9 
@@ -540,19 +552,19 @@
                 !--test OB 
                 !--for now we do not scavenge in cvltr
-                flag_cvltr(it)=.false.
+                flag_cvltr(it)=.FALSE.
 
              CASE('co2i')
                 !--co2 tracers are not scavenged
-                flag_cvltr(it)=.false.
+                flag_cvltr(it)=.FALSE.
 
 #ifdef CPP_StratAer
              CASE('coag')
                 IF (convscav.and.aerosol(it)) THEN
-                   flag_cvltr(it)=.true.
+                   flag_cvltr(it)=.TRUE.
                    ccntrAA(it) =ccntrAA_in    
                    ccntrENV(it)=ccntrENV_in
                    coefcoli(it)=coefcoli_in
                 ELSE
-                   flag_cvltr(it)=.false.
+                   flag_cvltr(it)=.FALSE.
                 ENDIF
 #endif
@@ -562,5 +574,5 @@
           !
        ELSE ! iflag_con .ne. 3 
-          flag_cvltr(:) = .false. 
+          flag_cvltr(:) = .FALSE. 
        ENDIF
        !
@@ -590,8 +602,8 @@
        IF (lessivage .AND. type_trac .EQ. 'inca') THEN
           CALL abort_physic('phytrac', 'lessivage=T config_inca=inca impossible',1)
-          STOP
+!          STOP
        ENDIF
        !
-    END IF ! of IF (debutphy)
+    ENDIF ! of IF (debutphy)
     !############################################ END INITIALIZATION #######
 
@@ -637,6 +649,7 @@
        !   -- CO2 interactif --
        !   -- source is updated with FF and BB emissions 
-       !   -- OB => PC need to add net flux from ocean and orchidee 
+       !   -- and net fluxes from ocean and orchidee 
        !   -- sign convention : positive into the atmosphere
+
        CALL tracco2i(pdtphys, debutphy, &
             xlat, xlon, pphis, pphi, &
@@ -754,5 +767,5 @@
 #endif
 
-    END IF ! convection
+    ENDIF ! convection
 
     !======================================================================
@@ -792,5 +805,5 @@
        END DO ! it
 
-    END IF ! Thermiques
+    ENDIF ! Thermiques
 
     !======================================================================
@@ -878,5 +891,5 @@
        CALL abort_physic('iflag_vdf_trac', 'cas non prevu',1)
        !
-    END IF ! couche limite
+    ENDIF ! couche limite
 
     !======================================================================
@@ -968,6 +981,6 @@
                       zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
                       !
-                   END DO
-                END DO
+                   ENDDO
+                ENDDO
 
                 DO k=klev-1, 1, -1
@@ -1014,8 +1027,8 @@
                       !                                (1.-1./(frac_impa(i,k)*frac_nucl(i,k)))
                       !--------------
-                   END DO
-                END DO
-             END IF
-          END DO
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDDO
           ! *********   end modified old version
 
@@ -1053,13 +1066,13 @@
                       ! ----------------------------------------------------------------------
                       tr_seri(i,k,it)=tr_seri(i,k,it)*frac_impa(i,k)*frac_nucl(i,k)
-                   END DO
-                END DO
-             END IF
-          END DO
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDDO
 
           ! *********   end old version
        ENDIF  !  iflag_lscav . EQ. 1, 2, 3 or 4
        !
-    END IF !  lessivage
+    ENDIF !  lessivage
 
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/radlwsw_m.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/radlwsw_m.F90	(revision 3605)
@@ -16,5 +16,5 @@
    t,q,wo,&
    cldfra, cldemi, cldtaupd,&
-   ok_ade, ok_aie, flag_aerosol,&
+   ok_ade, ok_aie, ok_volcan, flag_aerosol,&
    flag_aerosol_strat, flag_aer_feedback, &
    tau_aero, piz_aero, cg_aero,&
@@ -25,4 +25,5 @@
    ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
    heat,heat0,cool,cool0,albpla,&
+   heat_volc, cool_volc,&
    topsw,toplw,solsw,sollw,&
    sollwdown,&
@@ -100,4 +101,5 @@
   ! ok_ade---input-L- apply the Aerosol Direct Effect or not?
   ! ok_aie---input-L- apply the Aerosol Indirect Effect or not?
+  ! ok_volcan-input-L- activate volcanic diags (SW heat & LW cool rate, SW & LW flux)
   ! flag_aerosol-input-I- aerosol flag from 0 to 6
   ! flag_aerosol_strat-input-I- use stratospheric aerosols flag (0, 1, 2)
@@ -120,4 +122,7 @@
   ! solswai---output-R- ray. solaire net absorbe a la surface (aerosol ind)
   ! topswai---output-R- ray. solaire absorbe au sommet de l'atm. (aerosol ind)
+  !
+  ! heat_volc-----output-R- echauffement atmospherique  du au forcage volcanique (visible) (K/s)
+  ! cool_volc-----output-R- refroidissement dans l'IR du au forcage volcanique (K/s)
   !
   ! ATTENTION: swai and swad have to be interpreted in the following manner:
@@ -193,4 +198,5 @@
 
   LOGICAL, INTENT(in)  :: ok_ade, ok_aie                                 ! switches whether to use aerosol direct (indirect) effects or not
+  LOGICAL, INTENT(in)  :: ok_volcan                                      ! produce volcanic diags (SW/LW heat flux and rate)
   LOGICAL              :: lldebug
   INTEGER, INTENT(in)  :: flag_aerosol                                   ! takes value 0 (no aerosol) or 1 to 6 (aerosols)
@@ -228,4 +234,5 @@
   REAL,    INTENT(out) :: heat(KLON,KLEV), cool(KLON,KLEV)
   REAL,    INTENT(out) :: heat0(KLON,KLEV), cool0(KLON,KLEV)
+  REAL,    INTENT(out) :: heat_volc(KLON,KLEV), cool_volc(KLON,KLEV) !NL
   REAL,    INTENT(out) :: topsw(KLON), toplw(KLON)
   REAL,    INTENT(out) :: solsw(KLON), sollw(KLON), albpla(KLON)
@@ -294,4 +301,5 @@
   REAL(KIND=8) zheat(kdlon,kflev), zcool(kdlon,kflev)
   REAL(KIND=8) zheat0(kdlon,kflev), zcool0(kdlon,kflev)
+  REAL(KIND=8) zheat_volc(kdlon,kflev), zcool_volc(kdlon,kflev) !NL
   REAL(KIND=8) ztopsw(kdlon), ztoplw(kdlon)
   REAL(KIND=8) zsolsw(kdlon), zsollw(kdlon), zalbpla(kdlon)
@@ -308,4 +316,7 @@
   REAL(KIND=8) ztopswad0aero(kdlon), zsolswad0aero(kdlon)   ! Aerosol direct forcing at TOAand surface
   REAL(KIND=8) ztopswaiaero(kdlon), zsolswaiaero(kdlon)     ! dito, indirect
+!--NL
+  REAL(KIND=8) zswadaero(kdlon,kflev+1)                       ! SW Aerosol direct forcing
+  REAL(KIND=8) zlwadaero(kdlon,kflev+1)                       ! LW Aerosol direct forcing
 !-LW by CK
   REAL(KIND=8) ztoplwadaero(kdlon), zsollwadaero(kdlon)     ! LW Aerosol direct forcing at TOAand surface
@@ -398,5 +409,20 @@
   cgaero(:,:,:,:)=0.
   lldebug=.FALSE.
-  
+
+  ztopsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  ztopsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+
+
+   ZTOPSWADAERO(:)  = 0. !ym missing init
+   ZSOLSWADAERO(:)  = 0. !ym missing init
+   ZTOPSWAD0AERO(:) = 0. !ym missing init
+   ZSOLSWAD0AERO(:) = 0. !ym missing init
+   ZTOPSWAIAERO(:)  = 0. !ym missing init 
+   ZSOLSWAIAERO(:)  = 0. !ym missing init  
+   ZTOPSWCF_AERO(:,:)= 0.!ym missing init  
+   ZSOLSWCF_AERO(:,:) =0. !ym missing init  
+
   !
   !-------------------------------------------
@@ -415,4 +441,6 @@
       heat(i,k)=0.
       cool(i,k)=0.
+      heat_volc(i,k)=0. !NL
+      cool_volc(i,k)=0. !NL
       heat0(i,k)=0.
       cool0(i,k)=0.
@@ -558,8 +586,9 @@
       ENDDO
       DO k = 1, kflev
-      DO i = 1, kdlon
-      zcool(i,k)=0.
-      zcool0(i,k)=0.
-      ENDDO
+         DO i = 1, kdlon
+            zcool(i,k)=0.
+            zcool_volc(i,k)=0. !NL
+            zcool0(i,k)=0.
+         ENDDO
       ENDDO
       DO i = 1, kdlon
@@ -584,27 +613,29 @@
 !----- Mise a zero des tableaux output du rayonnement SW-AR4 
       DO k = 1, kflev+1
-      DO i = 1, kdlon
-      ZFSUP(i,k)=0.
-      ZFSDN(i,k)=0.
-      ZFSUP0(i,k)=0.
-      ZFSDN0(i,k)=0.
-      ZFSUPC0(i,k)=0.
-      ZFSDNC0(i,k)=0.
-      ZFLUPC0(i,k)=0.
-      ZFLDNC0(i,k)=0.
-      ZSWFT0_i(i,k)=0.
-      ZFCUP_i(i,k)=0.
-      ZFCDWN_i(i,k)=0.
-      ZFCCUP_i(i,k)=0.
-      ZFCCDWN_i(i,k)=0.
-      ZFLCCUP_i(i,k)=0.
-      ZFLCCDWN_i(i,k)=0.
-      ENDDO
+         DO i = 1, kdlon
+            ZFSUP(i,k)=0.
+            ZFSDN(i,k)=0.
+            ZFSUP0(i,k)=0.
+            ZFSDN0(i,k)=0.
+            ZFSUPC0(i,k)=0.
+            ZFSDNC0(i,k)=0.
+            ZFLUPC0(i,k)=0.
+            ZFLDNC0(i,k)=0.
+            ZSWFT0_i(i,k)=0.
+            ZFCUP_i(i,k)=0.
+            ZFCDWN_i(i,k)=0.
+            ZFCCUP_i(i,k)=0.
+            ZFCCDWN_i(i,k)=0.
+            ZFLCCUP_i(i,k)=0.
+            ZFLCCDWN_i(i,k)=0.
+            zswadaero(i,k)=0. !--NL
+         ENDDO
       ENDDO
       DO k = 1, kflev
-      DO i = 1, kdlon
-      zheat(i,k)=0.
-      zheat0(i,k)=0.
-      ENDDO
+         DO i = 1, kdlon
+            zheat(i,k)=0.
+            zheat_volc(i,k)=0.
+            zheat0(i,k)=0.
+         ENDDO
       ENDDO
       DO i = 1, kdlon
@@ -708,6 +739,6 @@
 !
 !--OB
-!--aerosol TOT  - anthropogenic+natural
-!--aerosol NAT  - natural only
+!--aerosol TOT  - anthropogenic+natural - index 2
+!--aerosol NAT  - natural only          - index 1
 !
       DO i = 1, kdlon
@@ -729,6 +760,6 @@
 !
 !--C. Kleinschmitt
-!--aerosol TOT  - anthropogenic+natural
-!--aerosol NAT  - natural only
+!--aerosol TOT  - anthropogenic+natural - index 2
+!--aerosol NAT  - natural only          - index 1
 !
       DO i = 1, kdlon
@@ -854,8 +885,10 @@
          ZTOPSWAIAERO,ZSOLSWAIAERO, &
          ZTOPSWCF_AERO,ZSOLSWCF_AERO, &
+         ZSWADAERO, & !--NL
          ZTOPLWADAERO,ZSOLLWADAERO,&  ! rajoute par C. Kleinscmitt pour LW diagnostics
          ZTOPLWAD0AERO,ZSOLLWAD0AERO,&
          ZTOPLWAIAERO,ZSOLLWAIAERO, &
-         ok_ade, ok_aie, flag_aerosol,flag_aerosol_strat, flag_aer_feedback) ! flags aerosols
+         ZLWADAERO, & !--NL
+         ok_ade, ok_aie, ok_volcan, flag_aerosol,flag_aerosol_strat, flag_aer_feedback) ! flags aerosols
             
 !        print *,'RADLWSW: apres RECMWF'
@@ -936,4 +969,8 @@
          ZFLDNC0(i,k+1)= ZFLCCDWN_i(i,k+1)
          ZFLUPC0(i,k+1)= ZFLCCUP_i(i,k+1)
+         IF(ok_volcan) THEN
+            ZSWADAERO(i,k+1)=ZSWADAERO(i,k+1)*fract(i) !--NL
+         ENDIF
+         
 !   Nouveau calcul car visiblement ZSWFT et ZSWFC sont nuls dans RRTM cy32
 !   en sortie de radlsw.F90 - MPL 7.01.09
@@ -1016,4 +1053,8 @@
            zcool(i,k)=(ZLWFT(i,k)-ZLWFT(i,k+1))*RDAY*RG/RCPD/PDP(i,k)
            zcool0(i,k)=(ZLWFT0_i(i,k)-ZLWFT0_i(i,k+1))*RDAY*RG/RCPD/PDP(i,k)
+           IF(ok_volcan) THEN
+              zheat_volc(i,k)=(ZSWADAERO(i,k+1)-ZSWADAERO(i,k))*RG/RCPD/PDP(i,k) !NL
+              zcool_volc(i,k)=(ZLWADAERO(i,k)-ZLWADAERO(i,k+1))*RG/RCPD/PDP(i,k) !NL
+           ENDIF
 !          print *,'heat cool heat0 cool0 ',zheat(i,k),zcool(i,k),zheat0(i,k),zcool0(i,k)
 !	   ZFLUCUP_i(i,k)=ZFLUC_i(i,1,k)
@@ -1125,4 +1166,8 @@
         heat0(iof+i,k) = zheat0(i,k)/zznormcp
         cool0(iof+i,k) = zcool0(i,k)/zznormcp
+        IF(ok_volcan) THEN !NL
+           heat_volc(iof+i,k) = zheat_volc(i,k)/zznormcp
+           cool_volc(iof+i,k) = zcool_volc(i,k)/zznormcp
+        ENDIF
       ENDDO
     ENDDO
